
/* Chrysalide - Outil d'analyse de fichiers binaires
 * cregisters.h - prototypes pour les aides auxiliaires relatives aux registres de co-processeur ARMv7
 *
 * Copyright (C) 2016-2017 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _PLUGINS_ARM_V7_CREGISTER_H
#define _PLUGINS_ARM_V7_CREGISTER_H


#include <glib-object.h>
#include <stdint.h>



#define G_TYPE_ARMV7_CREGISTER               g_armv7_cregister_get_type()
#define G_ARMV7_CREGISTER(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_armv7_cregister_get_type(), GArmV7CRegister))
#define G_IS_ARMV7_CREGISTER(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_armv7_cregister_get_type()))
#define G_ARMV7_CREGISTER_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_ARMV7_CREGISTER, GArmV7CRegisterClass))
#define G_IS_ARMV7_CREGISTER_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_ARMV7_CREGISTER))
#define G_ARMV7_CREGISTER_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_ARMV7_CREGISTER, GArmV7CRegisterClass))


/* Représentation d'un registre de co-processeur ARMv7 (instance) */
typedef struct _GArmV7CRegister GArmV7CRegister;

/* Représentation d'un registre de co-processeur ARMv7 (classe) */
typedef struct _GArmV7CRegisterClass GArmV7CRegisterClass;


/* Indique le type défini pour une représentation d'un registre de co-processeur ARMv7. */
GType g_armv7_cregister_get_type(void);

/* Crée une réprésentation de registre de co-processeur ARMv7. */
GArmV7CRegister *g_armv7_cregister_new(uint8_t);



#endif  /* _PLUGINS_ARM_V7_CREGISTER_H */
